aboutsummaryrefslogtreecommitdiff
path: root/contrib/convert-grafts-to-replace-refs.sh
diff options
context:
space:
mode:
authorChristian Couder <chriscool@tuxfamily.org>2014-07-19 17:01:11 +0200
committerJunio C Hamano <gitster@pobox.com>2014-07-21 12:05:53 -0700
commitb0ab2b71d0baa845e6920a3146df65f5cd296ea0 (patch)
tree130af4c8c35e1cc3e2b72e306a8ceeaa65fcb8b4 /contrib/convert-grafts-to-replace-refs.sh
parent78024c4e31d04cd2bdc0d734ede2d24bb33c72ef (diff)
downloadgit-b0ab2b71d0baa845e6920a3146df65f5cd296ea0.tar.gz
git-b0ab2b71d0baa845e6920a3146df65f5cd296ea0.tar.xz
contrib: add convert-grafts-to-replace-refs.sh
This patch adds into contrib/ an example script to convert grafts from an existing grafts file into replace refs using the new --graft option of "git replace". While at it let's mention this new script in the "git replace" documentation for the --graft option. Signed-off-by: Christian Couder <chriscool@tuxfamily.org> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'contrib/convert-grafts-to-replace-refs.sh')
-rwxr-xr-xcontrib/convert-grafts-to-replace-refs.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/contrib/convert-grafts-to-replace-refs.sh b/contrib/convert-grafts-to-replace-refs.sh
new file mode 100755
index 000000000..0cbc917b8
--- /dev/null
+++ b/contrib/convert-grafts-to-replace-refs.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+# You should execute this script in the repository where you
+# want to convert grafts to replace refs.
+
+GRAFTS_FILE="${GIT_DIR:-.git}/info/grafts"
+
+. $(git --exec-path)/git-sh-setup
+
+test -f "$GRAFTS_FILE" || die "Could not find graft file: '$GRAFTS_FILE'"
+
+grep '^[^# ]' "$GRAFTS_FILE" |
+while read definition
+do
+ if test -n "$definition"
+ then
+ echo "Converting: $definition"
+ git replace --graft $definition ||
+ die "Conversion failed for: $definition"
+ fi
+done
+
+mv "$GRAFTS_FILE" "$GRAFTS_FILE.bak" ||
+ die "Could not rename '$GRAFTS_FILE' to '$GRAFTS_FILE.bak'"
+
+echo "Success!"
+echo "All the grafts in '$GRAFTS_FILE' have been converted to replace refs!"
+echo "The grafts file '$GRAFTS_FILE' has been renamed: '$GRAFTS_FILE.bak'"